/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (6.2.1).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package cl.globallogic.api.domain.controller;

import cl.globallogic.api.domain.dto.UserDTO;
import cl.globallogic.api.domain.exception.ErrorDTO;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.context.request.NativeWebRequest;

import javax.annotation.Generated;
import javax.validation.Valid;
import java.util.Optional;

@Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-02-12T06:52:00.592348300-03:00[America/Santiago]")
@Validated
@Tag(name = "sign-up", description = "the sign-up API")
public interface SignUpApi {


    /**
     * POST /sign-up : Sign-up Method
     *
     * @param userDTO  (required)
     * @return OK (status code 200)
     */
    @Operation(
            operationId = "sign",
            summary = "Sign-up Method",
            responses = {
                    @ApiResponse(responseCode = "201", description = "Created", content = {
                            @Content(mediaType = "application/json", schema = @Schema(implementation = UserDTO.class))
                    }),
                    @ApiResponse(responseCode = "400", description = "Bad Request", content = {
                            @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorDTO.class))
                    }),
                    @ApiResponse(responseCode = "500", description = "Internal Server Error", content = {
                            @Content(mediaType = "application/json", schema = @Schema(implementation = ErrorDTO.class))
                    })
            }
    )
    @RequestMapping(
            method = RequestMethod.POST,
            value = "/sign-up",
            produces = { "application/json" },
            consumes = { "application/json" }
    )
    ResponseEntity<UserDTO> sign(
            @Parameter(name = "UserDTO", description = "", required = true) @Valid @RequestBody UserDTO userDTO
    );


}